// C Source File
// Created 12/1/2002; 12:52:58 PM

#define USE_TI89              // Produce .89z File
#define USE_TI92PLUS          // Produce .9xz File

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

// Main Function
void _main(void)
{
	int k;
	int password=0;
	ClrScr();
	FontSetSys(F_6x8);
	DrawStr(LCD_WIDTH/2-75,LCD_HEIGHT/2-4,"Philip Shirey's Calc-Lock",A_REVERSE);
	OSFreeTimer (USER_TIMER);
	OSRegisterTimer (USER_TIMER, 40);
	while (!OSTimerExpired (USER_TIMER));
	ClrScr();
	FontSetSys(F_4x6);
	DrawStr(0,0,"This calculator is under a lock.",A_XOR);
	DrawStr(0,10,"To use it, type the secret password",A_XOR);
	DrawStr(0,20,"within 10 seconds.",A_XOR);
offagain:
	password=0;
	off();
	OSFreeTimer (USER_TIMER);
	OSRegisterTimer (USER_TIMER, 200);
	while (1==1){
		k=ngetchx();
		if (k=='w'){
			if (password==0)
				password++;
			else
				password=0;
			goto endjump;
		}
		if (k=='0'){
			if (password==1||password==2)
				password++;
			else
				password=0;
			goto endjump;
		}
		if (k=='t'){
			if (password==3)
				password++;
			else
				password=0;
		}
endjump:
		if (password==4) break;
		if (OSTimerExpired (USER_TIMER)){
			password=0;
			break;
		}
	}
	if (!password)	goto offagain;
	ClrScr();
	FontSetSys(F_8x10);
	DrawStr(LCD_WIDTH/2-64,LCD_HEIGHT/2-10,"Congratulations!",A_REVERSE);
	DrawStr(LCD_WIDTH/2-80,LCD_HEIGHT/2,"You got the password",A_REVERSE);
	OSFreeTimer (USER_TIMER);
	OSRegisterTimer (USER_TIMER, 35);
	while (!OSTimerExpired (USER_TIMER));
}
